OpenTTD Source: NWidgetResizeBase Class Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Data Fields
NWidgetResizeBase Class Reference
Hierarchical widgets

Base class for a resizable nested widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetResizeBase:

## Public Member Functions
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets. More...
void | AdjustPaddingForZoom () override
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget. More...
void | SetMinimalSizeAbsolute (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | SetMinimalTextLines (uint8_t min_lines, uint8_t spacing, FontSize size)
| Set minimal text lines for the widget. More...
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size. More...
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget. More...
bool | UpdateMultilineWidgetSize (const std::string &str, int max_lines)
| Try to set optimum widget size for a multiline text widget. More...
bool | UpdateSize (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
bool | UpdateVerticalSize (uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual void | SetupSmallestSize (Window *w)=0
virtual void | FillWidgetLookup (WidgetLookup &widget_lookup)=0
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)=0
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | Draw (const Window *w)=0
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Data Fields
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
bool | absolute
| Set if minimum size is fixed and should not be resized.
uint | uz_min_x
| Unscaled Minimal horizontal size of only this widget.
uint | uz_min_y
| Unscaled Minimal vertical size of only this widget.
uint8_t | uz_text_lines
| 'Unscaled' text lines, stored for resize calculation.
uint8_t | uz_text_spacing
| 'Unscaled' text padding, stored for resize calculation.
FontSize | uz_text_size
| 'Unscaled' font size, stored for resize calculation.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Base class for a resizable nested widget.

Definition at line 291 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetResizeBase()

NWidgetResizeBase::NWidgetResizeBase | ( | WidgetType | tp,
|  | uint | fill_x,
|  | uint | fill_y
| ) |  |

Constructor for resizable nested widgets.

Parameters

  tp | Nested widget type.
  fill_x | Horizontal fill step size, `0` means no filling is allowed.
  fill_y | Vertical fill step size, `0` means no filling is allowed.

Definition at line 939 of file widget.cpp.

References NWidgetBase::fill_x, and NWidgetBase::fill_y.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetResizeBase::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| overridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Reimplemented in NWidgetBackground.

Definition at line 1063 of file widget.cpp.

## ◆ SetFill()

void NWidgetResizeBase::SetFill | ( | uint | fill_x,
|  | uint | fill_y
| ) |  |

Set the filling of the widget from initial size.

Parameters

  fill_x | Horizontal fill step size, `0` means no filling is allowed.
  fill_y | Vertical fill step size, `0` means no filling is allowed.

Definition at line 998 of file widget.cpp.

References NWidgetBase::fill_x, and NWidgetBase::fill_y.

Referenced by NWidgetLeaf::NWidgetLeaf(), and NWidgetScrollbar::NWidgetScrollbar().

## ◆ SetMinimalSize()

void NWidgetResizeBase::SetMinimalSize | ( | uint | min_x,
|  | uint | min_y
| ) |  |

Set minimal size of the widget.

Parameters

  min_x | Horizontal minimal size of the widget.
  min_y | Vertical minimal size of the widget.

Definition at line 959 of file widget.cpp.

References GetCharacterHeight(), ScaleGUITrad(), uz_min_x, uz_min_y, uz_text_lines, uz_text_size, and uz_text_spacing.

Referenced by MakeNWidget(), and NWidgetSpacer::NWidgetSpacer().

## ◆ SetMinimalSizeAbsolute()

void NWidgetResizeBase::SetMinimalSizeAbsolute | ( | uint | min_x,
|  | uint | min_y
| ) |  |

Set absolute (post-scaling) minimal size of the widget.

Parameters

  min_x | Horizontal minimal size of the widget.
  min_y | Vertical minimal size of the widget.

Definition at line 972 of file widget.cpp.

References absolute, min_x, and min_y.

Referenced by NWidgetScrollbar::SetupSmallestSize().

## ◆ SetMinimalTextLines()

void NWidgetResizeBase::SetMinimalTextLines | ( | uint8_t | min_lines,
|  | uint8_t | spacing,
|  | FontSize | size
| ) |  |

Set minimal text lines for the widget.

Parameters

  min_lines | Number of text lines of the widget.
  spacing | Extra unscaled spacing (eg WidgetDimensions::unscaled.framerect.Vertical()) of the widget.
  size | Font size of text.

Definition at line 985 of file widget.cpp.

References GetCharacterHeight(), min_y, ScaleGUITrad(), uz_min_y, uz_text_lines, uz_text_size, and uz_text_spacing.

## ◆ SetResize()

void NWidgetResizeBase::SetResize | ( | uint | resize_x,
|  | uint | resize_y
| ) |  |

Set resize step of the widget.

Parameters

  resize_x | Resize step in horizontal direction, value `0` means no resize, otherwise the step size in pixels.
  resize_y | Resize step in vertical direction, value `0` means no resize, otherwise the step size in pixels.

Definition at line 1009 of file widget.cpp.

References NWidgetBase::resize_x, and NWidgetBase::resize_y.

Referenced by MakeNWidget(), NWidgetLeaf::NWidgetLeaf(), NWidgetScrollbar::NWidgetScrollbar(), and NWidgetSpacer::NWidgetSpacer().

## ◆ UpdateMultilineWidgetSize()

bool NWidgetResizeBase::UpdateMultilineWidgetSize | ( | const std::string & | str,
|  | int | max_lines
| ) |  |

Try to set optimum widget size for a multiline text widget.

The window will need to be reinited if the size is changed.

Parameters

  str | Multiline string contents that will fill the widget.
  max_line | Maximum number of lines.

Returns
  true iff the widget minimum size has changed.

Definition at line 1022 of file widget.cpp.

## ◆ UpdateSize()

bool NWidgetResizeBase::UpdateSize | ( | uint | min_x,
|  | uint | min_y
| ) |  |

Set absolute (post-scaling) minimal size of the widget.

The window will need to be reinited if the size is changed.

Parameters

  min_x | Horizontal minimal size of the widget.
  min_y | Vertical minimal size of the widget.

Returns
  true iff the widget minimum size has changed.

Definition at line 1042 of file widget.cpp.

References min_x, and min_y.

## ◆ UpdateVerticalSize()

bool NWidgetResizeBase::UpdateVerticalSize | ( | uint | min_y | ) |

Set absolute (post-scaling) minimal size of the widget.

The window will need to be reinited if the size is changed.

Parameters

  min_y | Vertical minimal size of the widget.

Returns
  true iff the widget minimum size has changed.

Definition at line 1056 of file widget.cpp.

References min_y.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp